(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role14 () Role)
(declare-fun role13 () Role)
(declare-fun role11 () Role)
(declare-fun role20 () Role)
(declare-fun role17 () Role)
(declare-fun role31 () Role)
(declare-fun role32 () Role)
(declare-fun role9 () Role)
(declare-fun role24 () Role)
(declare-fun role23 () Role)
(declare-fun role10 () Role)
(declare-fun role22 () Role)
(declare-fun role25 () Role)
(declare-fun role18 () Role)
(declare-fun role28 () Role)
(declare-fun role16 () Role)
(declare-fun role21 () Role)
(declare-fun role7 () Role)
(declare-fun role4 () Role)
(declare-fun role15 () Role)
(declare-fun role5 () Role)
(declare-fun role27 () Role)
(declare-fun role3 () Role)
(declare-fun role8 () Role)
(declare-fun role6 () Role)
(declare-fun role29 () Role)
(declare-fun role26 () Role)
(declare-fun role30 () Role)
(declare-fun role19 () Role)
(declare-fun role2 () Role)
(declare-fun role12 () Role)
(declare-fun role1 () Role)
(assert (forall ((x Role)) (or (= role14 x) (= role13 x) (= role11 x) (= role20 x) (= role17 x) (= role31 x) (= role32 x) (= role9 x) (= role24 x) (= role23 x) (= role10 x) (= role22 x) (= role25 x) (= role18 x) (= role28 x) (= role16 x) (= role21 x) (= role7 x) (= role4 x) (= role15 x) (= role5 x) (= role27 x) (= role3 x) (= role8 x) (= role6 x) (= role29 x) (= role26 x) (= role30 x) (= role19 x) (= role2 x) (= role12 x) (= role1 x))))
(assert (distinct role14 role13 role11 role20 role17 role31 role32 role9 role24 role23 role10 role22 role25 role18 role28 role16 role21 role7 role4 role15 role5 role27 role3 role8 role6 role29 role26 role30 role19 role2 role12 role1))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(assert (mu role32 role14))
(assert (mu role31 role13))
(assert (mu role31 role6))
(assert (mu role31 role1))
(assert (mu role30 role8))
(assert (mu role29 role14))
(assert (mu role29 role10))
(assert (mu role29 role7))
(assert (mu role28 role16))
(assert (mu role27 role11))
(assert (mu role27 role9))
(assert (mu role27 role2))
(assert (mu role26 role10))
(assert (mu role25 role11))
(assert (mu role25 role6))
(assert (mu role23 role15))
(assert (mu role23 role4))
(assert (mu role22 role12))
(assert (mu role21 role9))
(assert (mu role21 role5))
(assert (mu role19 role15))
(assert (mu role18 role13))
(assert (mu role18 role12))
(assert (mu role18 role3))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (ua Z2 Z5)) (= role7 Z1) (not (= role7 Z4)) (not (= role25 Z6)) (not (= role25 Z4)) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2) (mu Z1 role7) (not (= role25 Z5)) (not (= role7 Z6)) (not (= role7 Z5)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (ua Z2 Z5)) (= role7 Z1) (not (= role7 Z4)) (not (= role25 Z6)) (not (= role25 Z4)) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2) (mu Z1 role7) (not (= role25 Z5)) (not (= role7 Z6)) (not (= role7 Z5)))))
(push 1)
(assert (not (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (ua Z2 Z1) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (= role25 Z5)) (mu Z1 role7) (mu Z4 role2) (mu Z5 role5) (mu Z6 role7) (not (= role25 Z4)) (not (= role25 Z6))))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role25 Z3) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z1 Role) (Z2 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z4)) (not (ua Z2 Z6)) (not (ua Z2 Z5)) (= role7 Z1) (not (= role7 Z4)) (not (= role25 Z6)) (not (= role25 Z4)) (mu Z6 role7) (mu Z5 role5) (mu Z4 role2) (mu Z1 role7) (not (= role25 Z5)) (not (= role7 Z6)) (not (= role7 Z5)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
