(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role26 () Role)
(declare-fun role24 () Role)
(declare-fun role16 () Role)
(declare-fun role27 () Role)
(declare-fun role23 () Role)
(declare-fun role25 () Role)
(declare-fun role18 () Role)
(declare-fun role29 () Role)
(declare-fun role17 () Role)
(declare-fun role20 () Role)
(declare-fun role21 () Role)
(declare-fun role11 () Role)
(declare-fun role30 () Role)
(declare-fun role32 () Role)
(declare-fun role31 () Role)
(declare-fun role9 () Role)
(declare-fun role19 () Role)
(declare-fun role10 () Role)
(declare-fun role5 () Role)
(declare-fun role4 () Role)
(declare-fun role8 () Role)
(declare-fun role22 () Role)
(declare-fun role13 () Role)
(declare-fun role14 () Role)
(declare-fun role3 () Role)
(declare-fun role6 () Role)
(declare-fun role7 () Role)
(declare-fun role15 () Role)
(declare-fun role2 () Role)
(declare-fun role28 () Role)
(declare-fun role1 () Role)
(declare-fun role12 () Role)
(assert (forall ((x Role)) (or (= role26 x) (= role24 x) (= role16 x) (= role27 x) (= role23 x) (= role25 x) (= role18 x) (= role29 x) (= role17 x) (= role20 x) (= role21 x) (= role11 x) (= role30 x) (= role32 x) (= role31 x) (= role9 x) (= role19 x) (= role10 x) (= role5 x) (= role4 x) (= role8 x) (= role22 x) (= role13 x) (= role14 x) (= role3 x) (= role6 x) (= role7 x) (= role15 x) (= role2 x) (= role28 x) (= role1 x) (= role12 x))))
(assert (distinct role26 role24 role16 role27 role23 role25 role18 role29 role17 role20 role21 role11 role30 role32 role31 role9 role19 role10 role5 role4 role8 role22 role13 role14 role3 role6 role7 role15 role2 role28 role1 role12))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(assert (mu role32 role19))
(assert (mu role32 role17))
(assert (mu role31 role23))
(assert (mu role31 role20))
(assert (mu role30 role18))
(assert (mu role29 role24))
(assert (mu role29 role22))
(assert (mu role29 role21))
(assert (mu role28 role24))
(assert (mu role28 role23))
(assert (mu role27 role18))
(assert (mu role27 role17))
(assert (mu role26 role23))
(assert (mu role26 role18))
(assert (mu role24 role15))
(assert (mu role24 role10))
(assert (mu role23 role16))
(assert (mu role23 role12))
(assert (mu role23 role9))
(assert (mu role22 role16))
(assert (mu role22 role15))
(assert (mu role22 role11))
(assert (mu role20 role15))
(assert (mu role20 role12))
(assert (mu role20 role9))
(assert (mu role19 role10))
(assert (mu role18 role14))
(assert (mu role18 role13))
(assert (mu role18 role11))
(assert (mu role17 role16))
(assert (mu role16 role6))
(assert (mu role16 role4))
(assert (mu role16 role2))
(assert (mu role15 role7))
(assert (mu role15 role3))
(assert (mu role15 role1))
(assert (mu role13 role8))
(assert (mu role13 role7))
(assert (mu role13 role3))
(assert (mu role12 role2))
(assert (mu role11 role7))
(assert (mu role11 role5))
(assert (mu role10 role7))
(assert (mu role10 role1))
(assert (mu role9 role7))
(assert (mu role9 role4))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role9))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role9))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role9))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role19))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role19))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role19))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role23))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role29 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role29 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role29 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role7) (mu Z5 role2) (mu Z4 role4) (mu Z3 role14))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role7) (mu Z5 role2) (mu Z4 role4) (mu Z3 role14))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role7) (mu Z5 role2) (mu Z4 role4) (mu Z3 role14))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role5) (mu Z5 role4) (mu Z4 role3) (mu Z3 role8))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role5) (mu Z5 role4) (mu Z4 role3) (mu Z3 role8))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role5) (mu Z5 role4) (mu Z4 role3) (mu Z3 role8))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role31 Z3) (mu Z6 role2) (mu Z5 role4) (mu Z4 role8))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role31 Z3) (mu Z6 role2) (mu Z5 role4) (mu Z4 role8))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role31 Z3) (mu Z6 role2) (mu Z5 role4) (mu Z4 role8))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role9))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z2 User) (Z3 Role)) (and (= role28 Z3) (= Z2 Z0) (mu Z3 role9))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z2 User) (Z3 Role)) (and (= role28 Z3) (= Z2 Z0) (mu Z3 role9))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role9)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z2 User) (Z3 Role)) (and (= role28 Z3) (= Z2 Z0) (mu Z3 role9))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
