(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role29 () Role)
(declare-fun role26 () Role)
(declare-fun role23 () Role)
(declare-fun role18 () Role)
(declare-fun role12 () Role)
(declare-fun role28 () Role)
(declare-fun role27 () Role)
(declare-fun role17 () Role)
(declare-fun role24 () Role)
(declare-fun role9 () Role)
(declare-fun role13 () Role)
(declare-fun role31 () Role)
(declare-fun role22 () Role)
(declare-fun role14 () Role)
(declare-fun role21 () Role)
(declare-fun role16 () Role)
(declare-fun role11 () Role)
(declare-fun role2 () Role)
(declare-fun role30 () Role)
(declare-fun role20 () Role)
(declare-fun role4 () Role)
(declare-fun role10 () Role)
(declare-fun role25 () Role)
(declare-fun role7 () Role)
(declare-fun role6 () Role)
(declare-fun role15 () Role)
(declare-fun role3 () Role)
(declare-fun role19 () Role)
(declare-fun role5 () Role)
(declare-fun role32 () Role)
(declare-fun role1 () Role)
(declare-fun role8 () Role)
(assert (forall ((x Role)) (or (= role29 x) (= role26 x) (= role23 x) (= role18 x) (= role12 x) (= role28 x) (= role27 x) (= role17 x) (= role24 x) (= role9 x) (= role13 x) (= role31 x) (= role22 x) (= role14 x) (= role21 x) (= role16 x) (= role11 x) (= role2 x) (= role30 x) (= role20 x) (= role4 x) (= role10 x) (= role25 x) (= role7 x) (= role6 x) (= role15 x) (= role3 x) (= role19 x) (= role5 x) (= role32 x) (= role1 x) (= role8 x))))
(assert (distinct role29 role26 role23 role18 role12 role28 role27 role17 role24 role9 role13 role31 role22 role14 role21 role16 role11 role2 role30 role20 role4 role10 role25 role7 role6 role15 role3 role19 role5 role32 role1 role8))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(assert (mu role32 role31))
(assert (mu role31 role30))
(assert (mu role30 role29))
(assert (mu role29 role28))
(assert (mu role28 role27))
(assert (mu role27 role26))
(assert (mu role26 role25))
(assert (mu role25 role24))
(assert (mu role24 role23))
(assert (mu role23 role22))
(assert (mu role22 role21))
(assert (mu role21 role20))
(assert (mu role20 role19))
(assert (mu role19 role18))
(assert (mu role18 role17))
(assert (mu role17 role16))
(assert (mu role16 role15))
(assert (mu role15 role14))
(assert (mu role14 role13))
(assert (mu role13 role12))
(assert (mu role12 role11))
(assert (mu role11 role10))
(assert (mu role10 role9))
(assert (mu role9 role8))
(assert (mu role8 role7))
(assert (mu role7 role6))
(assert (mu role6 role5))
(assert (mu role5 role4))
(assert (mu role4 role3))
(assert (mu role3 role2))
(assert (mu role2 role1))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role5))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role5))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role5))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role5))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z2 User) (Z3 Role)) (and (= role16 Z3) (= Z2 Z0) (mu Z3 role5))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z2 User) (Z3 Role)) (and (= role16 Z3) (= Z2 Z0) (mu Z3 role5))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (mu Z3 role5)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z2 User) (Z3 Role)) (and (= role16 Z3) (= Z2 Z0) (mu Z3 role5))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status sat)
(check-sat)
(pop 1)
(exit)
