(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role29 () Role)
(declare-fun role24 () Role)
(declare-fun role23 () Role)
(declare-fun role12 () Role)
(declare-fun role31 () Role)
(declare-fun role17 () Role)
(declare-fun role27 () Role)
(declare-fun role20 () Role)
(declare-fun role28 () Role)
(declare-fun role22 () Role)
(declare-fun role9 () Role)
(declare-fun role15 () Role)
(declare-fun role1 () Role)
(declare-fun role5 () Role)
(declare-fun role11 () Role)
(declare-fun role30 () Role)
(declare-fun role26 () Role)
(declare-fun role6 () Role)
(declare-fun role13 () Role)
(declare-fun role21 () Role)
(declare-fun role14 () Role)
(declare-fun role16 () Role)
(declare-fun role19 () Role)
(declare-fun role8 () Role)
(declare-fun role4 () Role)
(declare-fun role32 () Role)
(declare-fun role18 () Role)
(declare-fun role3 () Role)
(declare-fun role7 () Role)
(declare-fun role10 () Role)
(declare-fun role2 () Role)
(declare-fun role25 () Role)
(assert (forall ((x Role)) (or (= role29 x) (= role24 x) (= role23 x) (= role12 x) (= role31 x) (= role17 x) (= role27 x) (= role20 x) (= role28 x) (= role22 x) (= role9 x) (= role15 x) (= role1 x) (= role5 x) (= role11 x) (= role30 x) (= role26 x) (= role6 x) (= role13 x) (= role21 x) (= role14 x) (= role16 x) (= role19 x) (= role8 x) (= role4 x) (= role32 x) (= role18 x) (= role3 x) (= role7 x) (= role10 x) (= role2 x) (= role25 x))))
(assert (distinct role29 role24 role23 role12 role31 role17 role27 role20 role28 role22 role9 role15 role1 role5 role11 role30 role26 role6 role13 role21 role14 role16 role19 role8 role4 role32 role18 role3 role7 role10 role2 role25))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role4 Z6) (= role8 Z5) (= role1 Z4) (= role27 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role4 Z6) (= role8 Z5) (= role1 Z4) (= role27 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role4 Z6) (= role8 Z5) (= role1 Z4) (= role27 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role4 Z6) (= role8 Z5) (= role1 Z4) (= role27 Z1))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (let ((?v_0 (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))) (not (= ?v_0 ?v_0))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role4 Z6) (= role8 Z5) (= role1 Z4) (= role27 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role16 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role7 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (not (ua Z0 Z6)) (= role4 Z6) (= role8 Z5) (= role1 Z4) (not (= role27 Z5)) (not (= role27 Z4)) (not (= role27 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status sat)
(check-sat)
(pop 1)
(exit)
