(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role11 () Role)
(declare-fun role2 () Role)
(declare-fun role7 () Role)
(declare-fun role5 () Role)
(declare-fun role4 () Role)
(declare-fun role10 () Role)
(declare-fun role6 () Role)
(declare-fun role8 () Role)
(declare-fun role15 () Role)
(declare-fun role13 () Role)
(declare-fun role3 () Role)
(declare-fun role9 () Role)
(declare-fun role32 () Role)
(declare-fun role31 () Role)
(declare-fun role30 () Role)
(declare-fun role29 () Role)
(declare-fun role28 () Role)
(declare-fun role27 () Role)
(declare-fun role26 () Role)
(declare-fun role25 () Role)
(declare-fun role24 () Role)
(declare-fun role23 () Role)
(declare-fun role22 () Role)
(declare-fun role21 () Role)
(declare-fun role20 () Role)
(declare-fun role19 () Role)
(declare-fun role18 () Role)
(declare-fun role17 () Role)
(declare-fun role16 () Role)
(declare-fun role14 () Role)
(declare-fun role1 () Role)
(declare-fun role12 () Role)
(assert (forall ((x Role)) (or (= role11 x) (= role2 x) (= role7 x) (= role5 x) (= role4 x) (= role10 x) (= role6 x) (= role8 x) (= role15 x) (= role13 x) (= role3 x) (= role9 x) (= role32 x) (= role31 x) (= role30 x) (= role29 x) (= role28 x) (= role27 x) (= role26 x) (= role25 x) (= role24 x) (= role23 x) (= role22 x) (= role21 x) (= role20 x) (= role19 x) (= role18 x) (= role17 x) (= role16 x) (= role14 x) (= role1 x) (= role12 x))))
(assert (distinct role11 role2 role7 role5 role4 role10 role6 role8 role15 role13 role3 role9 role32 role31 role30 role29 role28 role27 role26 role25 role24 role23 role22 role21 role20 role19 role18 role17 role16 role14 role1 role12))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role10 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role10 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z0 User) (Z1 Role)) (and (= role10 Z1) (= Z0 Z2))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z0 User) (Z1 Role)) (and (= role10 Z1) (= Z0 Z2))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role10 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z0 User) (Z1 Role)) (and (= role10 Z1) (= Z0 Z2))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status sat)
(check-sat)
(pop 1)
(exit)
