(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role24 () Role)
(declare-fun role16 () Role)
(declare-fun role17 () Role)
(declare-fun role20 () Role)
(declare-fun role11 () Role)
(declare-fun role30 () Role)
(declare-fun role27 () Role)
(declare-fun role21 () Role)
(declare-fun role9 () Role)
(declare-fun role26 () Role)
(declare-fun role10 () Role)
(declare-fun role5 () Role)
(declare-fun role25 () Role)
(declare-fun role4 () Role)
(declare-fun role8 () Role)
(declare-fun role13 () Role)
(declare-fun role32 () Role)
(declare-fun role29 () Role)
(declare-fun role14 () Role)
(declare-fun role23 () Role)
(declare-fun role19 () Role)
(declare-fun role7 () Role)
(declare-fun role6 () Role)
(declare-fun role3 () Role)
(declare-fun role15 () Role)
(declare-fun role31 () Role)
(declare-fun role2 () Role)
(declare-fun role28 () Role)
(declare-fun role22 () Role)
(declare-fun role18 () Role)
(declare-fun role1 () Role)
(declare-fun role12 () Role)
(assert (forall ((x Role)) (or (= role24 x) (= role16 x) (= role17 x) (= role20 x) (= role11 x) (= role30 x) (= role27 x) (= role21 x) (= role9 x) (= role26 x) (= role10 x) (= role5 x) (= role25 x) (= role4 x) (= role8 x) (= role13 x) (= role32 x) (= role29 x) (= role14 x) (= role23 x) (= role19 x) (= role7 x) (= role6 x) (= role3 x) (= role15 x) (= role31 x) (= role2 x) (= role28 x) (= role22 x) (= role18 x) (= role1 x) (= role12 x))))
(assert (distinct role24 role16 role17 role20 role11 role30 role27 role21 role9 role26 role10 role5 role25 role4 role8 role13 role32 role29 role14 role23 role19 role7 role6 role3 role15 role31 role2 role28 role22 role18 role1 role12))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role27 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role27 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role27 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role27 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role7 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role7 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role7 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role6 Z5) (= role2 Z4) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role6 Z5) (= role2 Z4) (= role20 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role)) (and (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role6 Z5) (= role2 Z4) (= role20 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role5 Z6) (= role2 Z5) (= role8 Z4) (= role19 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role5 Z6) (= role2 Z5) (= role8 Z4) (= role19 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role5 Z6) (= role2 Z5) (= role8 Z4) (= role19 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role7 Z6) (= role1 Z5) (= role8 Z4) (= role31 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role7 Z6) (= role1 Z5) (= role8 Z4) (= role31 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z0 Z6)) (not (ua Z0 Z5)) (not (ua Z0 Z4)) (ua Z0 Z1) (= role7 Z6) (= role1 Z5) (= role8 Z4) (= role31 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role22 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role22 Z1))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role22 Z1))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role31 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role31 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role1 Z3))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role1 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role1 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role22 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role22 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role22 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role18 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role18 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role18 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role12 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role12 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role12 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role19 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role23 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role29 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role29 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role29 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role32 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role32 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role32 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role29 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role29 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role29 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role14 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role14 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role7 Z6) (= role4 Z5) (= role2 Z4) (= role14 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role5 Z6) (= role4 Z5) (= role3 Z4) (= role30 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role5 Z6) (= role4 Z5) (= role3 Z4) (= role30 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role5 Z6) (= role4 Z5) (= role3 Z4) (= role8 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role5 Z6) (= role4 Z5) (= role3 Z4) (= role8 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role5 Z6) (= role4 Z5) (= role3 Z4) (= role8 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role4 Z6) (= role2 Z5) (= role8 Z4) (= role31 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (= role4 Z6) (= role2 Z5) (= role8 Z4) (= role31 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unsat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role22 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role22 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role22 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role18 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role18 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role18 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role12 Z3))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role12 Z3))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role12 Z3))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role7 Z1))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z0 User) (Z1 Role)) (and (= role7 Z1) (= Z0 Z2))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z0 User) (Z1 Role)) (and (= role7 Z1) (= Z0 Z2))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role7 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role29 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role9 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role21 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role1 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role31 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role9 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role21 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role)) (and (ua Z2 Z3) (= role27 Z3)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role30 Z1)))))
(set-info :status unknown)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z0 User) (Z1 Role)) (and (= role7 Z1) (= Z0 Z2))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unknown)
(check-sat)
(pop 1)
(exit)
