(set-info :smt-lib-version 2.6)
(set-logic UFLRA)
(set-info :source |
  Generated with ASASP.
  ASASP (http://st.fbk.eu/technologies/asasp) implements a symbolic reachability procedure
  for the analysis of administrative access control policies.  A more detailed description
  of the benchmarks can be found in the following paper: Efficient Symbolic Automated Analysis
  of Administrative Attribute-based RBAC-Policies, by F. Alberti, A. Armando, and S. Ranise, in
  ASIACCS 2011.  For info contact Francesco Alberti <francesco.alberti@usi.ch>
|)
(set-info :category "industrial")
(declare-sort User 0)
(declare-fun u1 () User)
(assert (forall ((x User)) (= u1 x)))
(declare-sort Role 0)
(declare-fun role27 () Role)
(declare-fun role21 () Role)
(declare-fun role14 () Role)
(declare-fun role12 () Role)
(declare-fun role11 () Role)
(declare-fun role26 () Role)
(declare-fun role18 () Role)
(declare-fun role31 () Role)
(declare-fun role29 () Role)
(declare-fun role19 () Role)
(declare-fun role32 () Role)
(declare-fun role25 () Role)
(declare-fun role24 () Role)
(declare-fun role16 () Role)
(declare-fun role22 () Role)
(declare-fun role30 () Role)
(declare-fun role23 () Role)
(declare-fun role13 () Role)
(declare-fun role28 () Role)
(declare-fun role4 () Role)
(declare-fun role7 () Role)
(declare-fun role5 () Role)
(declare-fun role9 () Role)
(declare-fun role1 () Role)
(declare-fun role10 () Role)
(declare-fun role20 () Role)
(declare-fun role17 () Role)
(declare-fun role6 () Role)
(declare-fun role8 () Role)
(declare-fun role3 () Role)
(declare-fun role2 () Role)
(declare-fun role15 () Role)
(assert (forall ((x Role)) (or (= role27 x) (= role21 x) (= role14 x) (= role12 x) (= role11 x) (= role26 x) (= role18 x) (= role31 x) (= role29 x) (= role19 x) (= role32 x) (= role25 x) (= role24 x) (= role16 x) (= role22 x) (= role30 x) (= role23 x) (= role13 x) (= role28 x) (= role4 x) (= role7 x) (= role5 x) (= role9 x) (= role1 x) (= role10 x) (= role20 x) (= role17 x) (= role6 x) (= role8 x) (= role3 x) (= role2 x) (= role15 x))))
(assert (distinct role27 role21 role14 role12 role11 role26 role18 role31 role29 role19 role32 role25 role24 role16 role22 role30 role23 role13 role28 role4 role7 role5 role9 role1 role10 role20 role17 role6 role8 role3 role2 role15))
(declare-sort Permission 0)
(declare-fun ua (User Role) Bool)
(declare-fun rh (Role Role) Bool)
(declare-fun pa (User Permission) Bool)
(declare-fun mu (Role Role) Bool)
(declare-fun attr (User Real) Bool)
(assert true)
(assert true)
(assert true)
(assert true)
(assert (forall ((u User) (v1 Real) (v2 Real)) (or (not (and (attr u v1) (attr u v2))) (= v2 v1))))
(assert (forall ((r1 Role) (r2 Role) (r3 Role)) (or (not (and (mu r1 r2) (mu r2 r3))) (mu r1 r3))))
(assert (forall ((r Role)) (mu r r)))
(assert (forall ((r1 Role) (r2 Role)) (or (not (and (mu r1 r2) (mu r2 r1))) (= r2 r1))))
(assert (mu role32 role28))
(assert (mu role32 role25))
(assert (mu role31 role27))
(assert (mu role31 role26))
(assert (mu role30 role27))
(assert (mu role30 role26))
(assert (mu role30 role25))
(assert (mu role29 role27))
(assert (mu role29 role26))
(assert (mu role28 role24))
(assert (mu role28 role22))
(assert (mu role28 role21))
(assert (mu role27 role24))
(assert (mu role27 role22))
(assert (mu role27 role21))
(assert (mu role26 role24))
(assert (mu role26 role23))
(assert (mu role26 role21))
(assert (mu role25 role24))
(assert (mu role25 role21))
(assert (mu role24 role20))
(assert (mu role24 role18))
(assert (mu role24 role17))
(assert (mu role23 role19))
(assert (mu role23 role17))
(assert (mu role22 role20))
(assert (mu role22 role18))
(assert (mu role21 role19))
(assert (mu role21 role18))
(assert (mu role20 role15))
(assert (mu role20 role14))
(assert (mu role20 role13))
(assert (mu role19 role14))
(assert (mu role19 role13))
(assert (mu role18 role15))
(assert (mu role18 role14))
(assert (mu role18 role13))
(assert (mu role17 role16))
(assert (mu role17 role14))
(assert (mu role17 role13))
(assert (mu role16 role12))
(assert (mu role16 role11))
(assert (mu role16 role9))
(assert (mu role15 role11))
(assert (mu role15 role10))
(assert (mu role15 role9))
(assert (mu role14 role12))
(assert (mu role14 role11))
(assert (mu role14 role9))
(assert (mu role13 role12))
(assert (mu role13 role10))
(assert (mu role13 role9))
(assert (mu role12 role8))
(assert (mu role12 role7))
(assert (mu role12 role6))
(assert (mu role11 role7))
(assert (mu role11 role6))
(assert (mu role11 role5))
(assert (mu role10 role8))
(assert (mu role10 role6))
(assert (mu role9 role8))
(assert (mu role9 role6))
(assert (mu role9 role5))
(assert (mu role8 role4))
(assert (mu role8 role2))
(assert (mu role8 role1))
(assert (mu role7 role4))
(assert (mu role7 role2))
(assert (mu role7 role1))
(assert (mu role6 role4))
(assert (mu role6 role3))
(assert (mu role6 role2))
(assert (mu role5 role4))
(assert (mu role5 role3))
(assert (mu role5 role1))
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role4) (mu Z5 role8) (mu Z4 role3) (mu Z3 role6))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role4) (mu Z5 role8) (mu Z4 role3) (mu Z3 role6))))
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role4) (mu Z5 role8) (mu Z4 role3) (mu Z3 role6))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status unsat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role4) (mu Z5 role8) (mu Z4 role3) (mu Z3 role6))))
(set-info :status sat)
(check-sat)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (= role31 Z3) (not (= role31 Z5)) (mu Z3 role6) (mu Z4 role3) (mu Z5 role8) (mu Z6 role4) (not (= role31 Z4)) (not (= role31 Z6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (= role31 Z3) (not (= role31 Z5)) (mu Z3 role6) (mu Z4 role3) (mu Z5 role8) (mu Z6 role4) (not (= role31 Z4)) (not (= role31 Z6)))))
(push 1)
(assert (not (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z6)) (not (ua Z2 Z5)) (not (ua Z2 Z4)) (ua Z2 Z3) (mu Z6 role4) (mu Z5 role8) (mu Z4 role3) (mu Z3 role6)))))
(set-info :status sat)
(check-sat)
(pop 1)
(push 1)
(assert (not (exists ((Z0 User) (Z1 Role)) (and (ua Z0 Z1) (= role20 Z1)))))
(set-info :status sat)
(check-sat)
(pop 1)
(pop 1)
(push 1)
(assert (exists ((Z2 User) (Z3 Role) (Z4 Role) (Z5 Role) (Z6 Role)) (and (not (ua Z2 Z5)) (not (ua Z2 Z4)) (not (ua Z2 Z6)) (= role31 Z3) (not (= role31 Z5)) (mu Z3 role6) (mu Z4 role3) (mu Z5 role8) (mu Z6 role4) (not (= role31 Z4)) (not (= role31 Z6)))))
(assert (forall ((u User) (r Role)) (not (ua u r))))
(set-info :status sat)
(check-sat)
(pop 1)
(exit)
